* Example 4
* From Guimaraes & Portugal (2009)
* Estimates Poisson Regression with one fixed effect
* Replicates the estimates on page 348 of the [XT] Manual version 10

set more off
log using example4.log,replace

*webuse ships, clear
use ships, clear
qui poisson acc op_75_79 co_65_69 co_70_74 co_75_79, exposure(service) nolog
keep if e(sample)
bys ship: egen sumy=total(acc)
gen double off=0
gen double temp=0
local dif=1
local ll1=0
local i=0
while abs(`dif')>epsdouble() {
qui poisson acc op_75_79 co_65_69 co_70_74 co_75_79, off(off) nocon
local ll2=`ll1'
local ll1=e(ll)
capture drop xb
predict double xb, xb
qui replace temp=xb-off+log(service), nopromote
capture drop sumx
bys ship: egen double sumx=total(exp(temp))
qui replace off=log(sumy/sumx)+log(service), nopromote
local dif=`ll2'-`ll1'
local i=`i'+1
}
di "Total Number of Iterations --> " `i'
poisson acc op_75_79 co_65_69 co_70_74 co_75_79, nocon off(off) irr nolog

log close
exit

